︠608b0e28-1e7f-450a-9208-f49c64b55d95s︠
def Wiener (n, s):
    M = 10101
    E = M.powermod(s,n)#&^(M, s) % n
    cf = continued_fraction(n/s)# convert(n / s, confrac)
    m = len(cf)
    for i in range(0, m ):
        conv = cf.convergent(i)
        t = conv.numerator()
        #t = cf.quotient(i)#numtheory:-nthnumer(cf, i)
        d = E.powermod(t,n)#&^(E, t) % n
        #print d
        if d == M:
            print("k:= {0}".format(cf.convergent(i).denominator()))
            print("The totient of the modulus is {0}".format((s*t-1)/(cf.convergent(i).denominator())))
            print("The private key is {0}".format(t))
            return [t, (s*t-1)/(cf.convergent(i).denominator())]
    print("Private key not found")

def WienerCovert (P):
    p = next_prime(ZZ.random_element(P^2))
    q = next_prime(ZZ.random_element(P^2))
    while(not((q<p) and (p<2*q))):
        p = next_prime(ZZ.random_element(P^2))
        q = next_prime(ZZ.random_element(P^2))
    n = p*q
    phin = (p-1)*(q-1)
    l = ZZ(floor((n^(1/4))/3))
    for i in range(1000):
        d1 = l-i
        g = gcd(d1,phin)
        if (g == 1):
            s1 = 1/d1 % phin
            s2 = s1*P % n
            g1 = gcd(s2,phin)
            if(g1 == 1):
                d2 = 1/s2 % phin
                print "The modulus is: ", n
                print "The exponent is: ", s2
                print "The key is: ", d2
                return([n,s2,d2])
︡5042e81c-b9fa-47af-8255-c41d63c86375︡{"done":true}︡
︠376c6147-3419-4e31-b358-0929d16dc0fas︠


P = next_prime(983724836482)
R = WienerCovert(P)
print "end of creatiom of covert channel"
S = R[1]/P % R[0]
wienerAttackOutput = Wiener(R[0],S)
print "after wieners attack"
d = 1/R[1] % wienerAttackOutput[1]
d
if (R[2] == d):
    print "correct private key computed"
︡2ec1c302-ef17-4fb2-9559-afa7735f798b︡{"stdout":"The modulus is:  162996458187706035673135889099890482856112226697\nThe exponent is:  94344369869984932236004780866259533022210541589\nThe key is:  56419832253583618233458429492162599992204825621\n"}︡{"stdout":"end of creatiom of covert channel\n"}︡{"stdout":"k:= 22430205604\nThe totient of the modulus is 162996458187706035673135081204137668474884176916\nThe private key is 211798698559\n"}︡{"stdout":"after wieners attack\n"}︡{"stdout":"56419832253583618233458429492162599992204825621\n"}︡{"stdout":"correct private key computed\n"}︡{"done":true}︡
︠f7b3d280-bda1-4b38-8fe4-49924731d910︠
︡78c00f11-298f-4fb0-8664-24862454004d︡
︠e47101c1-cef1-461f-955a-6f833b0c108e︠
︡a7f4cd8b-3a81-480e-9820-c1cc140fc280︡{"done":true}︡
︠9143f692-2fda-45ef-9f9c-8f7d66fe1ac1︠









